## otb 6.6.1+dfsg

=== CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

cmake_minimum_required(VERSION 3.1.0)

foreach(p
    CMP0025 # CMake 3.0
    CMP0042 # CMake 3.0
    CMP0058 # CMake 3.3
    CMP0072 # CMake 3.11
    )
  if(POLICY ${p})
    cmake_policy(SET ${p} NEW)
  endif()
endforeach()

# CMP0046 : from CMake 3.0, old behaviour is more convenient
if(POLICY CMP0046)
  cmake_policy(SET CMP0046 OLD)
endif()

# TODO Check if OTB cmake is compatible with CMP0054 NEW policy
# CMP0054 : New policy introduce in CMake 3.1, keep old behaviour for now
if(POLICY CMP0054)
  cmake_policy(SET CMP0054 OLD)
endif()

project(OTB)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Check compiler versions
set(OTB_MIN_GNU_VER 5)
set(OTB_MIN_MSVC_VER 19)
set(OTB_MIN_Clang_VER 3.4)
if(DEFINED OTB_MIN_${CMAKE_CXX_COMPILER_ID}_VER)
  if(CMAKE_CXX_COMPILER_VERSION AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${OTB_MIN_${CMAKE_CXX_COMPILER_ID}_VER})
    message(STATUS "WARNING: the version of your ${CMAKE_CXX_COMPILER_ID} "
      "compiler is not supported by Orfeo ToolBox (C++14 support might be "
      "incomplete). Please consider updating your compiler to version "
      "${OTB_MIN_${CMAKE_CXX_COMPILER_ID}_VER} or later.")
  endif()
endif()

include(CMakeDependentOption)
#
# use ExternalProject
include(ExternalProject)

#mantis: 1193
if(APPLE)
  set(CMAKE_SYSTEM_FRAMEWORK_PATH "" CACHE PATH "" FORCE)
endif()

if( CMAKE_HOST_WIN32 )

  string( LENGTH "${CMAKE_CURRENT_SOURCE_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "OTB source code directory path length is too long (${n} > 50)."
      "Please move the OTB source code directory to a directory with a shorter path."
      )
  endif()

  string( LENGTH "${CMAKE_CURRENT_BINARY_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "OTB build directory path length is too long (${n} > 50)."
      "Please set the OTB build directory to a directory with a shorter path."
      )
  endif()

endif()
set(OTB_APPLICATIONS_NAME_LIST "" CACHE STRING "List of all applications" FORCE)
mark_as_advanced(OTB_APPLICATIONS_NAME_LIST)

set(OTB_CMAKE_DIR ${OTB_SOURCE_DIR}/CMake)
set(CMAKE_MODULE_PATH ${OTB_CMAKE_DIR} ${CMAKE_MODULE_PATH})
include (SourceStatus)
include(PreventInSourceBuilds)
include(PreventInBuildInstalls)
include(OTBModuleMacros)
include(OTBModuleRemote)
include(OTBModuleTest)
include( i18n_qt )

reset_qt_i18n_sources()

repository_status(${PROJECT_SOURCE_DIR} OTB_GIT_STATUS_MESSAGE)

#-----------------------------------------------------------------------------
# Configure the default OTB_DATA_ROOT for the location of OTB Data.
find_path(OTB_DATA_ROOT
  NAMES README-OTB-Data
  HINTS $ENV{OTB_DATA_ROOT} ${OTB_SOURCE_DIR}/../OTB-Data
)
#mark_as_advanced(OTB_DATA_ROOT)

if(OTB_DATA_ROOT)
  repository_status(${OTB_DATA_ROOT} OTB_DATA_GIT_STATUS_MESSAGE)
endif()

set(main_project_name ${_OTBModuleMacros_DEFAULT_LABEL})

#-----------------------------------------------------------------------------
# OTB version number.
set(OTB_VERSION_MAJOR "6")
set(OTB_VERSION_MINOR "6")
set(OTB_VERSION_PATCH "1")
set(OTB_VERSION_STRING "${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR}.${OTB_VERSION_PATCH}")

# Monteverdi version number (follows OTB)
set( Monteverdi_VERSION_MAJOR ${OTB_VERSION_MAJOR} )
set( Monteverdi_VERSION_MINOR ${OTB_VERSION_MINOR} )
set( Monteverdi_VERSION_PATCH ${OTB_VERSION_PATCH} )
set( Monteverdi_VERSION_SUFFIX "" )

set( Monteverdi_VERSION_STRING
  "${Monteverdi_VERSION_MAJOR}.${Monteverdi_VERSION_MINOR}.${Monteverdi_VERSION_PATCH}${Monteverdi_VERSION_SUFFIX}"
  )

#-----------------------------------------------------------------------------
string(TIMESTAMP OTB_BUILD_TIMESTAMP)

if(NOT OTB_INSTALL_RUNTIME_DIR)
  set(OTB_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT OTB_INSTALL_LIBRARY_DIR)
  set(OTB_INSTALL_LIBRARY_DIR lib)
endif()
if(NOT OTB_INSTALL_ARCHIVE_DIR)
  set(OTB_INSTALL_ARCHIVE_DIR lib)
endif()
if(NOT OTB_INSTALL_INCLUDE_DIR)
  set(OTB_INSTALL_INCLUDE_DIR include/OTB-${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR})
endif()
if(NOT OTB_INSTALL_APP_DIR)
  set(OTB_INSTALL_APP_DIR "${OTB_INSTALL_LIBRARY_DIR}/otb/applications")
endif()
if(NOT OTB_INSTALL_PYTHON_DIR)
  set(OTB_INSTALL_PYTHON_DIR "${OTB_INSTALL_LIBRARY_DIR}/otb/python")
endif()
if(NOT OTB_INSTALL_PYTHON3_DIR)
  set(OTB_INSTALL_PYTHON3_DIR "${OTB_INSTALL_LIBRARY_DIR}/otb/python3")
endif()
if(NOT OTB_INSTALL_JAVA_DIR)
  set(OTB_INSTALL_JAVA_DIR "${OTB_INSTALL_LIBRARY_DIR}/otb/java")
endif()
if(NOT OTB_INSTALL_DATA_DIR)
  set(OTB_INSTALL_DATA_DIR "share/otb")
endif()

if(NOT OTB_INSTALL_DOC_DIR)
  set(OTB_INSTALL_DOC_DIR "share/doc/otb")
endif()
if(NOT OTB_INSTALL_PACKAGE_DIR)
  set(OTB_INSTALL_PACKAGE_DIR "${OTB_INSTALL_LIBRARY_DIR}/cmake/OTB-${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR}")
endif()

#convert path to native for reconfiguring otbcli.bat.in
file(TO_NATIVE_PATH "${OTB_INSTALL_APP_DIR}" OTB_INSTALL_APP_DIR_NATIVE)

# Override CMake's built-in add_* commands: assign LABELS to tests and targets
# automatically. Depends on the CMake variable otb-module being set to the
# "current" module when add_* is called.
macro(verify_otb_module_is_set)
  if("" STREQUAL "${otb-module}")
    message(FATAL_ERROR "CMake variable otb-module is not set")
  endif()
endmacro()

#-----------------------------------------------------------------------------
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()


#-----------------------------------------------------------------------------
# Enable running cppcheck for each module on its source and test directories.
option(OTB_CPPCHECK_TEST "Run cppcheck for static code analysis" OFF)
mark_as_advanced(OTB_CPPCHECK_TEST)

#-----------------------------------------------------------------------------
# Forbid downloading resources from the network during a build. This helps
# when building on systems without network connectivity to determine which
# resources much be obtained manually and made available to the build.
option(OTB_FORBID_DOWNLOADS "Do not download source code or data from the network" OFF)
mark_as_advanced(OTB_FORBID_DOWNLOADS)
macro(otb_download_attempt_check _name)
  if(OTB_FORBID_DOWNLOADS)
    message(SEND_ERROR "Attempted to download ${_name} when OTB_FORBID_DOWNLOADS is ON")
  endif()
endmacro()

# TODO : handle shared libs on windows
option(BUILD_SHARED_LIBS "Build OTB with shared libraries." ON)
set(OTB_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

if(MSVC)
  option(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS "Build OTB with shared libraries." ON)
  set(OTB_CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ${CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS})
else()
  set(OTB_CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS OFF)
endif()

#-----------------------------------------------------------------------------
# Option to activate deprecated classes
option(OTB_USE_DEPRECATED "Turn on the use and test of deprecated classes" OFF)
mark_as_advanced(OTB_USE_DEPRECATED)

# Although the OpenMP option looks like a 3rd party module, it is NOT. This option
# is handled with other compilation flags in file OTBSetStandardCompilerFlags.cmake
# before any module is parsed or enabled (see OTBModuleEnablement.cmake later on
# during configure). Trying to modify this option from any module is
# useless. Any 3rd party module dragging OpenMP should append
# the corresponding flags to CMAKE_CXX_FLAGS, CMAKE_EXE_LINKER_FLAGS, and so on.
option(OTB_USE_OPENMP "Add openmp compiler and linker flags" OFF)

option(OTB_USE_SSE_FLAGS "Enable SIMD optimizations (hardware dependent)." ON)

include(OTBSetStandardCompilerFlags)
#---------------------------------------------------------------
# run try compiles and tests for OTB

# TODO check if we need this
#include(otbTestFriendTemplatedFunction)

set(CMAKE_C_FLAGS "${OTB_REQUIRED_C_FLAGS} ${CMAKE_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${OTB_REQUIRED_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${OTB_REQUIRED_LINK_FLAGS} ${CMAKE_EXE_LINKER_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "${OTB_REQUIRED_LINK_FLAGS} ${CMAKE_SHARED_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "${OTB_REQUIRED_LINK_FLAGS} ${CMAKE_MODULE_LINKER_FLAGS}")

# TODO BUILD_TESTING is created by default by CTest.cmake, and is ON by default.
option(BUILD_TESTING "Build the testing tree." OFF)

include(CTest)

include( CppcheckTargets )

# Setup build locations.
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${OTB_BINARY_DIR}/bin)
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${OTB_BINARY_DIR}/lib)
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${OTB_BINARY_DIR}/lib)
endif()
set(OTB_MODULES_DIR "${OTB_BINARY_DIR}/${OTB_INSTALL_PACKAGE_DIR}/Modules")

#-----------------------------------------------------------------------------
# OTB uses KWStyle for checking the coding style
#include(${OTB_SOURCE_DIR}/Utilities/KWStyle/KWStyle.cmake)

#-----------------------------------------------------------------------------
# By default, OTB does not build the Examples that are illustrated in the Software Guide
option(BUILD_EXAMPLES "Build the Examples directory." OFF)

#----------------------------------------------------------------------------
set(OTB_TEST_OUTPUT_DIR "${OTB_BINARY_DIR}/Testing/Temporary")

option(OTB_DATA_USE_LARGEINPUT "Use Large inputs images test." OFF)
mark_as_advanced(OTB_DATA_USE_LARGEINPUT)
if(OTB_DATA_USE_LARGEINPUT)
  find_path(OTB_DATA_LARGEINPUT_ROOT
    NAMES OTBData.readme
    HINTS $ENV{OTB_DATA_LARGEINPUT_ROOT}
  )
  mark_as_advanced(OTB_DATA_LARGEINPUT_ROOT)
endif()

# Small macro to copy a file and rename it
macro(otb_copy_rename _input _output)
  execute_process(
    COMMAND ${CMAKE_COMMAND} -E copy_if_different "${_input}" "${_output}"
    RESULT_VARIABLE _err_code
    OUTPUT_QUIET
    ERROR_QUIET
    )
  if(_err_code)
    message(FATAL_ERROR "Failed to copy file ${_input} to ${_output}")
  endif()
endmacro()

#Generate cmake variables with a set of largeinput data used in tests
include(OTBManageLargeInputPaths)

set(BASELINE       ${OTB_DATA_ROOT}/Baseline/OTB/Images)
set(BASELINE_FILES ${OTB_DATA_ROOT}/Baseline/OTB/Files)
set(INPUTDATA      ${OTB_DATA_ROOT}/Input)
set(TEMP           ${OTB_BINARY_DIR}/Testing/Temporary)
set(EXAMPLEDATA    ${OTB_DATA_ROOT}/Examples)
set(OTBAPP_BASELINE       ${OTB_DATA_ROOT}/Baseline/OTB-Applications/Images)
set(OTBAPP_BASELINE_FILES ${OTB_DATA_ROOT}/Baseline/OTB-Applications/Files)

set(NOTOL      0.0)
set(EPSILON_1  0.1)
set(EPSILON_2  0.01)
set(EPSILON_3  0.001)
set(EPSILON_4  0.0001)
set(EPSILON_5  0.00001)
set(EPSILON_6  0.000001)
set(EPSILON_7  0.0000001)
set(EPSILON_8  0.00000001)
set(EPSILON_9  0.000000001)
set(EPSILON_10 0.0000000001)
set(EPSILON_11 0.00000000001)
set(EPSILON_12 0.000000000001)
set(EPSILON_13 0.0000000000001)
set(EPSILON_14 0.00000000000001)
set(EPSILON_15 0.000000000000001)

# Location of OTB Example Data.

=== Examples/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

##### check if standalone project ######
if(NOT PROJECT_NAME)
  cmake_minimum_required(VERSION 3.1.0)
  project(OTBExamples)
endif()

#check if this is a standalone build?

if(PROJECT_NAME STREQUAL "OTBExamples")
  if(BUILD_TESTING)
    include(CTest)
  endif()

  # dashboard build. Why do I need to see the deprecated warnings on dashboard!
  # It just fades the actual warnings and most importantly very annoying.
  if(NOT "$ENV{DASHBOARD_TEST_FROM_CTEST}" STREQUAL "")
    if(UNIX)
      if(CMAKE_COMPILER_IS_GNUCXX)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-cpp")
      else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-#warnings")
      endif() #CMAKE_COMPILER_IS_GNUCXX
    endif() #UNIX
  endif()

  # --------------------------------------------------------------------------------
  # Manage PHR data input
  if(OTB_DATA_USE_LARGEINPUT)
    set(GenericTestPHR_DATA_INPUTS
      ${GenericTestPHR_DATA_INPUTS}
      ${OTB_DATA_LARGEINPUT_ROOT}/PLEIADES-PRE/TLSE_JP2_ORTHO_DIMAPv2_PMS-N_lossy_12bits/IMG_PHR1Z_PMS_N_001/IMG_PHR1A_PMS-N_201006181052297_ORT_IPU_20111011_0619-001_R1C1.JP2
      ${OTB_DATA_LARGEINPUT_ROOT}/PLEIADES-PRE/TLSE_TIFF_ORTHO_DIMAPv2_MS_lossless_8bits/IMG_PHR1A_MS_002/IMG_PHR1A_MS_201006181052297_ORT_IPU_20111109_7807-004_R1C1.TIF
      ${OTB_DATA_LARGEINPUT_ROOT}/PLEIADES-PRE/TLSE_TIFF_PRIMARY_DIMAPv2_MS_lossly_12bits/IMG_PHR1A_MS_002/IMG_PHR1A_MS_201006181052297_SEN_IPU_20111025_3077-004_R1C1.TIF
      ${OTB_DATA_LARGEINPUT_ROOT}/PLEIADES/TLSE_JP2_DIMAPv2_PRIMARY_PMS_lossless_12bits/IMGPHR_201222215194743808/IMG_PHR1A_PMS_201201151100183_SEN_IPU_20120222_0901-001_R2C1.JP2
      ${OTB_DATA_LARGEINPUT_ROOT}/PLEIADES/LASVEGAS_JP2_DIMAPv1_PRIMARY_PMS_lossless_12bits/IMGPHR_PHR1A_SENSOR_20120217_IPU_20120217_5374-001_V1/IMG_R1C1.JP2
      ${OTB_DATA_LARGEINPUT_ROOT}/PLEIADES/PARIS_JP2_DIMAPv1_ORTHO_PMS_lossless_12bits/IMGPHR_PHR1A_ORTHO_20120502_IPU_20120430_6347-003_V1/IMG_R1C1.JP2
      )

    set(GenericTestPHR_DATA_TYPES
      ${GenericTestPHR_DATA_TYPES}
      SIMUL_PHR_JP2_ORTHO_DIMAPv2_PMS-N_lossy_12bits
      SIMUL_PHR_TIFF_ORTHO_DIMAPv2_MS_lossless_8bits
      SIMUL_PHR_TIFF_PRIMARY_DIMAPv2_MS_lossy_12bits
      PHR_JP2_DIMAPv2_PRIMARY_PMS_lossless_12bits
      PHR_JP2_DIMAPv1_PRIMARY_PMS_lossless_12bits
      PHR_JP2_DIMAPv1_ORTHO_PMS_lossless_12bits
      )

    set(GenericTestSPOT6_DATA_INPUTS
      ${GenericTestSPOT6_DATA_INPUTS}
      ${OTB_DATA_LARGEINPUT_ROOT}/SPOT6/SPOT6_Ortho_Bundle_12_bits/PROD_SPOT6_001/VOL_SPOT6_001_A/IMG_SPOT6_MS_001_A/IMG_SPOT6_MS_201306031242000_ORT_816005101_R1C1.JP2
      ${OTB_DATA_LARGEINPUT_ROOT}/SPOT6/SPOT6_Ortho_Pan-sharpened_12_bits/PROD_SPOT6_001/VOL_SPOT6_001_A/IMG_SPOT6_PMS_001_A/IMG_SPOT6_PMS_201305251604372_ORT_816009101_R1C1.JP2
      ${OTB_DATA_LARGEINPUT_ROOT}/SPOT6/SPOT6_Primary_Bundle_12_bits/PROD_SPOT6_001/VOL_SPOT6_001_A/IMG_SPOT6_MS_001_A/IMG_SPOT6_MS_201211100138085_SEN_816007101_R1C1.JP2
      )

    set(GenericTestSPOT6_DATA_TYPES
      ${GenericTestSPOT6_DATA_TYPES}
      SPOT6_Ortho_Bundle_12_bits
      SPOT6_Ortho_Pan-sharpened_12_bits
      SPOT6_Primary_Bundle_12_bits
      )
  endif()


  ########################## copied from OTB/CMakeLists.txt ##########################

  #Generate cmake variables with a set of largeinput data used in tests
  set(BASELINE       ${OTB_DATA_ROOT}/Baseline/OTB/Images)
  set(BASELINE_FILES ${OTB_DATA_ROOT}/Baseline/OTB/Files)
  set(INPUTDATA      ${OTB_DATA_ROOT}/Input)
  set(TEMP           ${CMAKE_BINARY_DIR}/Testing/Temporary)
  set(EXAMPLEDATA    ${OTB_DATA_ROOT}/Examples)
  set(OTBAPP_BASELINE       ${OTB_DATA_ROOT}/Baseline/OTB-Applications/Images)
  set(OTBAPP_BASELINE_FILES ${OTB_DATA_ROOT}/Baseline/OTB-Applications/Files)

  set(NOTOL      0.0)
  set(EPSILON_1  0.1)
  set(EPSILON_2  0.01)
  set(EPSILON_3  0.001)
  set(EPSILON_4  0.0001)
  set(EPSILON_5  0.00001)
  set(EPSILON_6  0.000001)
  set(EPSILON_7  0.0000001)
  set(EPSILON_8  0.00000001)
  set(EPSILON_9  0.000000001)
  set(EPSILON_10 0.0000000001)
  set(EPSILON_11 0.00000000001)
  set(EPSILON_12 0.000000000001)
  set(EPSILON_13 0.0000000000001)
  set(EPSILON_14 0.00000000000001)
  set(EPSILON_15 0.000000000000001)

  #-----------------------------------------------------------------------------
  # OTB wrapper for add_test that automatically sets the test's LABELS property
  # to the value of its containing module.
  #
  function(otb_add_test)
    set(largeinput_regex "LARGEINPUT{([^;{}\r\n]*)}")
    set(_depends_on_largeinput OFF)
    foreach(arg IN LISTS ARGN)
      if("x${arg}" MATCHES "${largeinput_regex}")
        string(REGEX REPLACE "${largeinput_regex}" "\\1" largeinput_relative_path "${arg}")
        set(_fullpath "${OTB_DATA_LARGEINPUT_ROOT}/${largeinput_relative_path}")
        list(APPEND _out_arg ${_fullpath})
        set(_depends_on_largeinput ON)
      else()
        list(APPEND _out_arg ${arg})
      endif()
    endforeach()
    if (_depends_on_largeinput AND NOT OTB_DATA_USE_LARGEINPUT)
      return()
    endif()
    add_test(${_out_arg})
    if("NAME" STREQUAL "${ARGV0}")
      set(_iat_testname ${ARGV1})
    else()
      set(_iat_testname ${ARGV0})
    endif()
    if(otb-module)
      set(_label ${otb-module})
    else()
      set(_label ${main_project_name})
    endif()
    set_property(TEST ${_iat_testname} PROPERTY LABELS ${_label})
  endfunction()

  ########################## end copied from OTB/CMakeLists.txt ##########################
else()

  #Examples that require large input cannot be enabled when building as standalone
  include(${CMAKE_CURRENT_SOURCE_DIR}/../CMake/OTBManageLargeInputPaths.cmake)
endif()

find_package(OTB REQUIRED)
include(${OTB_USE_FILE})
message(STATUS "Found OTB: ${OTB_USE_FILE}")

set(OTB_TEST_DRIVER otbTestDriver)

if(OTBApplicationEngine_LOADED)
  add_subdirectory(Application)
endif()
add_subdirectory(BasicFilters)
add_subdirectory(ChangeDetection)
add_subdirectory(Classification)
add_subdirectory(DataRepresentation)
add_subdirectory(DimensionReduction)
add_subdirectory(DisparityMap)
add_subdirectory(FeatureExtraction)
add_subdirectory(Filtering)
add_subdirectory(Fusion)
add_subdirectory(Hyperspectral)
add_subdirectory(Installation)
add_subdirectory(IO)
add_subdirectory(Iterators)
add_subdirectory(Learning)
add_subdirectory(Markov)
add_subdirectory(MultiScale)
add_subdirectory(OBIA)
add_subdirectory(Patented)
add_subdirectory(Projections)
add_subdirectory(Radiometry)
add_subdirectory(Registration)
add_subdirectory(Segmentation)
add_subdirectory(Simulation)
add_subdirectory(Tutorials)

=== i18n/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#############################################################################
# Qt translations.
#----------------------------------------------------------------------------
# Locale human-readable translation files.
set( OTB_TS_TRANSLATIONS
# en_US.ts
  fr_FR.ts
)
unset(OTB_QM_TRANSLATIONS)

#----------------------------------------------------------------------------
# Configuration option to enable creation/merging of source .ts files
# Default value is: OFF.
option( OTB_I18N_MERGE_TS
  "Create/merge .ts source translation files. WARNING: If ON, 'make clean' will delete the .ts files from source directory!"
  OFF
  )

#----------------------------------------------------------------------------
if( OTBQt_ENABLED )
  # Generate commands to build Qt translations according to option.
  if( OTB_I18N_MERGE_TS )
    message(
      AUTHOR_WARNING
      "WARNING: OTB_I18N_MERGE_TS:BOOL option is set to ON. 'make clean' will delete .ts files from source directory!"
      )

    message( STATUS "Qt I18N source files: ${OTB_QT_I18N_SOURCE_FILES}")

    set( OTB_QT_I18N_PRO "${CMAKE_CURRENT_BINARY_DIR}/i18n.pro" )

    generate_qt_project( ${OTB_QT_I18N_PRO} )

    foreach(_ts_name ${OTB_TS_TRANSLATIONS})
      get_filename_component(_abs_ts ${_ts_name} ABSOLUTE)

      message( STATUS "Merge TS : ${_abs_ts}")
      add_custom_command(OUTPUT ${_abs_ts}
        COMMAND ${Qt5_LUPDATE_EXECUTABLE}
        ARGS -locations none -pro ${OTB_QT_I18N_PRO} -ts ${_abs_ts}
        DEPENDS
          ${OTB_QT_I18N_HEADER_FILES}
          ${OTB_QT_I18N_SOURCE_FILES}
          ${OTB_QT_I18N_FORM_FILES}
          ${OTB_QT_I18N_PRO}
        VERBATIM)
    endforeach()
  endif()

  qt5_add_translation(OTB_QM_TRANSLATIONS
      ${OTB_TS_TRANSLATIONS}
      )

  # Custom build targets.
  add_custom_target( i18n ALL DEPENDS i18n_qt )
  add_custom_target( i18n_qt DEPENDS ${OTB_QM_TRANSLATIONS} )

  # Locale human-readable translation files.
  install(
    FILES ${OTB_QM_TRANSLATIONS}
    DESTINATION ${OTB_INSTALL_DATA_DIR}/i18n
    COMPONENT Resources
    )
endif()

=== Examples/DimensionReduction/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(DimensionReductionExamples)

add_executable(ICAExample ICAExample.cxx)
target_link_libraries(ICAExample ${OTB_LIBRARIES})

add_executable(MaximumAutocorrelationFactor MaximumAutocorrelationFactor.cxx)
target_link_libraries(MaximumAutocorrelationFactor ${OTB_LIBRARIES})

add_executable(MNFExample MNFExample.cxx)
target_link_libraries(MNFExample ${OTB_LIBRARIES})

add_executable(NAPCAExample NAPCAExample.cxx)
target_link_libraries(NAPCAExample ${OTB_LIBRARIES})

add_executable(PCAExample PCAExample.cxx)
target_link_libraries(PCAExample ${OTB_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/DisparityMap/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(DisparityMapExamples)

add_executable(FineRegistrationImageFilterExample FineRegistrationImageFilterExample.cxx)
target_link_libraries(FineRegistrationImageFilterExample ${OTB_LIBRARIES})

add_executable(NCCRegistrationFilterExample NCCRegistrationFilterExample.cxx)
target_link_libraries(NCCRegistrationFilterExample ${OTB_LIBRARIES})

add_executable(SimpleDisparityMapEstimationExample SimpleDisparityMapEstimationExample.cxx)
target_link_libraries(SimpleDisparityMapEstimationExample ${OTB_LIBRARIES})

#StereoReconstructionExample depends OTBMathParser. But OTB_USE_MUPARSER is OFF
if(OTBMathParser_LOADED)
add_executable(StereoReconstructionExample StereoReconstructionExample.cxx)
target_link_libraries(StereoReconstructionExample ${OTB_LIBRARIES})
endif()

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/Iterators/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(IteratorsExamples)

add_executable(ImageLinearIteratorWithIndex2 ImageLinearIteratorWithIndex2.cxx)
target_link_libraries(ImageLinearIteratorWithIndex2 ${OTB_LIBRARIES})

add_executable(ImageLinearIteratorWithIndex ImageLinearIteratorWithIndex.cxx)
target_link_libraries(ImageLinearIteratorWithIndex ${OTB_LIBRARIES})

add_executable(ImageRandomConstIteratorWithIndex ImageRandomConstIteratorWithIndex.cxx)
target_link_libraries(ImageRandomConstIteratorWithIndex ${OTB_LIBRARIES})

add_executable(ImageRegionIterator ImageRegionIterator.cxx)
target_link_libraries(ImageRegionIterator ${OTB_LIBRARIES})

add_executable(ImageRegionIteratorWithIndex ImageRegionIteratorWithIndex.cxx)
target_link_libraries(ImageRegionIteratorWithIndex ${OTB_LIBRARIES})

add_executable(ImageSliceIteratorWithIndex ImageSliceIteratorWithIndex.cxx)
target_link_libraries(ImageSliceIteratorWithIndex ${OTB_LIBRARIES})

add_executable(IteratorsExamples IteratorsExamples.cxx)
target_link_libraries(IteratorsExamples ${OTB_LIBRARIES})

add_executable(NeighborhoodIterators1 NeighborhoodIterators1.cxx)
target_link_libraries(NeighborhoodIterators1 ${OTB_LIBRARIES})

add_executable(NeighborhoodIterators2 NeighborhoodIterators2.cxx)
target_link_libraries(NeighborhoodIterators2 ${OTB_LIBRARIES})

add_executable(NeighborhoodIterators3 NeighborhoodIterators3.cxx)
target_link_libraries(NeighborhoodIterators3 ${OTB_LIBRARIES})

add_executable(NeighborhoodIterators4 NeighborhoodIterators4.cxx)
target_link_libraries(NeighborhoodIterators4 ${OTB_LIBRARIES})

add_executable(NeighborhoodIterators5 NeighborhoodIterators5.cxx)
target_link_libraries(NeighborhoodIterators5 ${OTB_LIBRARIES})

add_executable(NeighborhoodIterators6 NeighborhoodIterators6.cxx)
target_link_libraries(NeighborhoodIterators6 ${OTB_LIBRARIES})

add_executable(ShapedNeighborhoodIterators1 ShapedNeighborhoodIterators1.cxx)
target_link_libraries(ShapedNeighborhoodIterators1 ${OTB_LIBRARIES})

add_executable(ShapedNeighborhoodIterators2 ShapedNeighborhoodIterators2.cxx)
target_link_libraries(ShapedNeighborhoodIterators2 ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/Tutorials/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(TutorialsExamples)

add_executable(FilteringPipeline FilteringPipeline.cxx)
target_link_libraries(FilteringPipeline ${OTB_LIBRARIES})

add_executable(HelloWorldOTB HelloWorldOTB.cxx)
target_link_libraries(HelloWorldOTB ${OTB_LIBRARIES})

add_executable(Multispectral Multispectral.cxx)
target_link_libraries(Multispectral ${OTB_LIBRARIES})

add_executable(OrthoFusion OrthoFusion.cxx)
target_link_libraries(OrthoFusion ${OTB_LIBRARIES})

add_executable(Pipeline Pipeline.cxx)
target_link_libraries(Pipeline ${OTB_LIBRARIES})

add_executable(ScalingPipeline ScalingPipeline.cxx)
target_link_libraries(ScalingPipeline ${OTB_LIBRARIES})

add_executable(SmarterFilteringPipeline SmarterFilteringPipeline.cxx)
target_link_libraries(SmarterFilteringPipeline ${OTB_LIBRARIES})


if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Utilities/Completion/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

find_package(OTB REQUIRED)
include(${OTB_USE_FILE})

add_executable(completionGenerator EXCLUDE_FROM_ALL completionGenerator.cxx)
target_link_libraries(completionGenerator ${OTB_LIBRARIES})

add_custom_target(generate-completion
    COMMAND bin/completionGenerator lib/otb/applications otbcli_completion
    DEPENDS completionGenerator
    WORKING_DIRECTORY ${OTB_BINARY_DIR}
    )

=== Utilities/Doxygen/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

#
# Build the documentation
#
include (${CMAKE_ROOT}/Modules/Documentation.cmake)

mark_as_advanced(BUILD_DOCUMENTATION)

# -------------------------------------------------------------
#
# Generate Doxygen configuration file in all configuration file
#
if( ${DOXYGEN_DOT_FOUND} )
  set( OTB_HAVE_DOT "YES" )
else()
  set( OTB_HAVE_DOT "NO" )
endif()

set( DOX_MODULE_LIST ${OTB_MODULES_ENABLED} )

foreach(otb-module ${DOX_MODULE_LIST})
  if(${otb-module}_IS_TEST)
    list( APPEND DOXYGEN_TEST_DIRS "\"${${otb-module}_SOURCE_DIR}\" \\\n ")
  else()
    if( EXISTS ${${otb-module}_SOURCE_DIR}/include )
      list( APPEND DOXYGEN_INCLUDE_DIRS "\"${${otb-module}_SOURCE_DIR}/include\" \\ \n")
    endif()
  endif()
endforeach()

list( APPEND DOXYGEN_TEST_DIRS "\"${OTB_SOURCE_DIR}/Examples\" \\\n")

# By definition DOXYGEN_TEST_DIRS can not be empty. In the worst case if
# BUILD_TESTING is turned OFF, there is only ${OTB_SOURCE_DIR}/Examples;
# thus we don't need to do any replacement in the string.
if( BUILD_TESTING )
  # replace ";" in the string by space+backslash+newline
  string( REPLACE ";" " \\\\n" DOXYGEN_TEST_DIRS ${DOXYGEN_TEST_DIRS} )
endif()

list( LENGTH DOXYGEN_INCLUDE_DIRS _doxygen_include_dirs_size )

if( ${_doxygen_include_dirs_size} GREATER 0 )
  # replace ";" in the string by space+backslash+newline
  string( REPLACE ";" " \\\\n" DOXYGEN_INCLUDE_DIRS ${DOXYGEN_INCLUDE_DIRS} )
endif()

#
# Configure the script and the doxyfile, then add target
#

set( OTB_DOXYGEN_OUTPUT_DIR ${OTB_BINARY_DIR}/Documentation/Doxygen )
file(MAKE_DIRECTORY ${OTB_DOXYGEN_OUTPUT_DIR})

set( OTB_DOXYGEN_INPUT ${DOXYGEN_INCLUDE_DIRS} )

SET( OTB_DOXYGEN_DIAGRAMS YES )

option( OTB_DOXYGEN_HTML "Doxygen will generate HTML Output" ON )
option( OTB_DOXYGEN_DOCSET "Doxygen will generate additional index files for Xcode 3" OFF )
option( OTB_DOXYGEN_CHM "Doxygen will generate Microsoft HTML help" OFF )
option( OTB_DOXYGEN_QHP "Doxygen will generate Qt Compressed Help" OFF )
option( OTB_DOXYGEN_ECLIPSEHELP "Doxygen will generate Eclipse help plugin" OFF )
option( OTB_DOXYGEN_LATEX "Doxygen will generate LaTeX output" OFF )
option( OTB_DOXYGEN_RTF "Doxygen will generate RTF output optimized for Word 97" OFF )
option( OTB_DOXYGEN_XML "Doxygen will generate XML output" OFF )

mark_as_advanced( OTB_DOXYGEN_HTML
  OTB_DOXYGEN_DOCSET
  OTB_DOXYGEN_CHM
  OTB_DOXYGEN_QHP
  OTB_DOXYGEN_ECLIPSEHELP
  OTB_DOXYGEN_LATEX
  OTB_DOXYGEN_RTF
  OTB_DOXYGEN_XML
)

set( OTB_DOXYGEN_OUTPUT
  HTML
  DOCSET
  CHM
  QHP
  ECLIPSEHELP
  LATEX
  RTF
  XML
)

foreach( var ${OTB_DOXYGEN_OUTPUT} )
  if( OTB_DOXYGEN_${var} )
    set( OTB_DOXYGEN_GEN_${var} "YES" )
  else()
    set( OTB_DOXYGEN_GEN_${var} "NO" )
  endif()
endforeach()

set(OTB_DOXYGEN_ITK_TAGFILE "" CACHE FILEPATH "Tagfile containing ITK doxygen")
mark_as_advanced(OTB_DOXYGEN_ITK_TAGFILE)

set(OTB_DOXYGEN_ITK_DOXYGEN_URL "" CACHE STRING "URL to ITK doxygen")
mark_as_advanced(OTB_DOXYGEN_ITK_DOXYGEN_URL)

if(("${OTB_DOXYGEN_ITK_TAGFILE}" STREQUAL "") OR ("${OTB_DOXYGEN_ITK_DOXYGEN_URL}" STREQUAL ""))
  set(OTB_DOXYGEN_TAGFILE_FIELD "")
else()
  set(OTB_DOXYGEN_TAGFILE_FIELD "${OTB_DOXYGEN_ITK_TAGFILE}=${OTB_DOXYGEN_ITK_DOXYGEN_URL}")
endif()

find_package( Perl )

if( PERL_FOUND )
  set( OTB_DOXYGEN_INPUT_FILTER
    "${PERL_EXECUTABLE} ${OTB_SOURCE_DIR}/Utilities/Doxygen/otbgroup.pl" )
else()
  set( OTB_DOXYGEN_INPUT_FILTER )
endif()

configure_file(${OTB_SOURCE_DIR}/Utilities/Doxygen/doxygen.config.in
               ${OTB_BINARY_DIR}/Utilities/Doxygen/doxygen.config)


#set( OTB_DOXYGEN_OUTPUT_DIR ${OTB_BINARY_DIR}/temp )

set( OTB_DOXYGEN_INPUT "\"INPUT_SINGLE_FILE\"" )

set( OTB_DOXYGEN_DIAGRAMS NO )


configure_file(${OTB_SOURCE_DIR}/Utilities/Doxygen/doxygen.config.in
               ${OTB_BINARY_DIR}/single-doxygen.config)

# -------------------------------------------------------------
if (BUILD_DOCUMENTATION)

  find_package( LATEX )

  if( NOT LATEX_COMPILER )
    message( "Warning: LaTeX not found. Formulas will not be generated in documentation." )
  endif()

  # Custom command to generate a examples page which include all OTB examples
  #add_custom_command( OUTPUT "${OTB_BINARY_DIR}/Documentation/Doxygen/Examples.dox"
  #  COMMAND ${CMAKE_COMMAND} -D "PROJECT_SOURCE_DIR:PATH=${OTB_SOURCE_DIR}"
  #  -D "OUTPUT_FILE:PATH=${OTB_BINARY_DIR}/Documentation/Doxygen/Examples.dox"
  #  -P "${OTB_SOURCE_DIR}/Utilities/Doxygen/GenerateExamplesDox.cmake"
  #  WORKING_DIRECTORY "${OTB_SOURCE_DIR}/Examples"
  #  DEPENDS "${OTB_SOURCE_DIR}/Examples" "${OTB_SOURCE_DIR}/Utilities/Doxygen/GenerateExamplesDox.cmake"
  #  )

  add_custom_target(Documentation-doxygen
    COMMAND ${DOXYGEN_EXECUTABLE} ${OTB_BINARY_DIR}/Utilities/Doxygen/doxygen.config
    # fix php section delimiters for PHP 7
    COMMAND ${PERL_EXECUTABLE} -i
      "${OTB_SOURCE_DIR}/Utilities/Doxygen/fix_php7.pl"
      "${OTB_BINARY_DIR}/Documentation/Doxygen/html/*.php"
    WORKING_DIRECTORY ${OTB_BINARY_DIR}/Utilities/Doxygen
    )
  
  add_custom_target(Documentation
    COMMAND ${CMAKE_COMMAND} -E tar cjf
      ${OTB_BINARY_DIR}/Documentation/Doxygen/OTB-Doxygen-${OTB_VERSION_MAJOR}.${OTB_VERSION_MINOR}.tar.bz2
      ${OTB_BINARY_DIR}/Documentation/Doxygen/html
    DEPENDS Documentation-doxygen
    WORKING_DIRECTORY ${OTB_BINARY_DIR}/Documentation/Doxygen
    )

  # Somehow the logo image is not copied into the html folder.
  # Here we ensure that the logo image ends up in the right directory
  # where html pages could find it.



  message( STATUS
           "To generate Doxygen's documentation, you need to build the Documentation target"
         )

endif (BUILD_DOCUMENTATION)

=== Utilities/InstallTest/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# Test "make install"
if("x${CMAKE_INSTALL_PREFIX}" MATCHES "^x${OTB_BINARY_DIR}/InstallTest$")
  otb_add_test(NAME Install
    COMMAND ${CMAKE_COMMAND} -DCONFIGURATION=$<CONFIGURATION>
                             -DOTB_BINARY_DIR=${OTB_BINARY_DIR}
                             -P ${CMAKE_CURRENT_SOURCE_DIR}/InstallTest.cmake
    )
endif()

=== Examples/DataRepresentation/Containers/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

project(ContainersExamples)

add_executable(TreeContainer TreeContainer.cxx )
target_link_libraries(TreeContainer ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/DisparityMap/test/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

set(BASELINE ${OTB_DATA_ROOT}/Baseline/Examples/DisparityMap)
set(INPUTDATA ${OTB_DATA_ROOT}/Examples)

# ------- SimpleDisparityMapEstimationExampleTest ----------

otb_add_test(NAME dmTeSimpleDisparityMapEstimationExampleTest COMMAND ${OTB_TEST_DRIVER}
  --compare-n-images ${NOTOL} 2
    ${BASELINE}/deformationFieldOutput.png
    ${TEMP}/deformationFieldOutput.png
    ${BASELINE}/resampledMovingOutput.png
    ${TEMP}/resampledMovingOutput.png
  Execute $<TARGET_FILE:SimpleDisparityMapEstimationExample>
    ${INPUTDATA}/StereoFixed.png
    ${INPUTDATA}/StereoMoving.png
    ${TEMP}/deformationFieldOutput.png
    ${TEMP}/resampledMovingOutput.png
    100 10 15 10 10 250 0.9
)

if(OTBMathParser_LOADED)
#otb_add_test(NAME dmTeStereoReconstructionExampleTest COMMAND ${OTB_TEST_DRIVER}
  #--compare-image ${NOTOL}
    #${BASELINE}/elevationOutput.tif
    #${TEMP}/elevationOutput.tif
  #Execute $<TARGET_FILE:StereoReconstructionExample>
    #${INPUTDATA}/sensor_stereo_left.tif
    #${INPUTDATA}/sensor_stereo_right.tif
    #${TEMP}/elevationOutput.tif
    #${TEMP}/elevationOutputPrintable.png
    #140
#)
endif()

=== debian/changelog ===
otb (6.6.1+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Drop Python 2 support.
  * Update symbols for i386.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 23 Jul 2019 15:10:02 +0200

otb (6.6.1+dfsg-2~exp1) experimental; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.4.0, no changes.
  * Add upstream patch to fix FTBFS with GDAL 2.5.0.
  * Add lintian overrides for file-references-package-build-path.
  * Enable muparserx support.
    (closes: #930772)
  * Update symbols for amd64.
  * Update gbp.conf to use --source-only-changes by default.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 11 Jul 2019 17:51:32 +0200

otb (6.6.1+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Update symbols for amd64 & i386.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 16 Dec 2018 09:09:37 +0100

otb (6.6.1+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update copyright years for Centre National d'Etudes Spatiales (CNES).
  * Update install paths.
  * Update symbols for amd64.
  * Add patch to fix VERSION file install.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 12 Dec 2018 12:20:56 +0100

otb (6.6.0+dfsg-5) unstable; urgency=medium

  * Team upload.
  * Remove shark support, no longer in testing due to RC bug.
  * Drop unused lintian override for spelling-error-in-binary.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 14 Nov 2018 07:00:08 +0100

otb (6.6.0+dfsg-4) unstable; urgency=medium

  * Add Build-Depends-Package field to symbols file.
  * Disable SSE on i386.
    (closes: #912594)
  * Update symbols for amd64 & i386.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 01 Nov 2018 21:08:31 +0100

otb (6.6.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.2.1, no changes.
  * Update libotb-dev qwt dependency for Qt5 too.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 27 Sep 2018 13:33:15 +0200

otb (6.6.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.1.5, no changes.
  * Drop autopkgtest to test installability.
  * Add lintian override for testsuite-autopkgtest-missing.
  * Drop unused overrides for spelling-error-in-binary.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 01 Aug 2018 12:02:41 +0200

=== debian/control ===
Source: otb
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Paolo Cavallini <cavallini@faunalia.it>,
           Rashad Kanavath <rashad.kanavath@c-s.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               dh-exec,
               dh-python,
               dpkg-dev (>= 1.16.1~),
               cmake (>= 3.1.0),
               libboost-date-time-dev,
               libboost-filesystem-dev,
               libboost-graph-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libexpat1-dev,
               libfftw3-dev,
               libgdal-dev (>= 1.10.0),
               libgeotiff-dev,
               libgl1-mesa-dev | libgl-dev,
               libglew-dev,
               libglfw3-dev,
               libinsighttoolkit4-dev,
               libkml-dev,
               libmuparser-dev,
               libmuparserx-dev,
               libopencv-dev,
               libopenthreads-dev,
               libossim-dev,
               libpng-dev,
               libqt5opengl5-dev,
               libqwt-qt5-dev,
               libsvm-dev,
               libtinyxml-dev,
               libtool,
               pkg-kde-tools,
               python3-dev,
               python3-numpy,
               qtbase5-dev,
               qttools5-dev,
               swig
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/otb
Vcs-Git: https://salsa.debian.org/debian-gis-team/otb.git
Homepage: http://www.orfeo-toolbox.org/

Package: libotb-dev
Architecture: any
Section: libdevel
Depends: cmake (>= 2.8.3),
         libboost-date-time-dev,
         libboost-filesystem-dev,
         libboost-graph-dev,
         libboost-program-options-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libgdal-dev (>= 1.10.0),
         libgeotiff-dev,
         libgl1-mesa-dev | libgl-dev,
         libglew-dev,
         libglfw3-dev,
         libinsighttoolkit4-dev,
         libkml-dev,
         libmuparser-dev,
         libmuparserx-dev,
         libopencv-dev,
         libopenthreads-dev,
         libossim-dev,
         libotbapplicationengine-6.6-1 (= ${binary:Version}),
         libotbcarto-6.6-1 (= ${binary:Version}),
         libotbcommandline-6.6-1 (= ${binary:Version}),
         libotbcommandlineparser-6.6-1 (= ${binary:Version}),
         libotbcommon-6.6-1 (= ${binary:Version}),
         libotbcurladapters-6.6-1 (= ${binary:Version}),
         libotbedge-6.6-1 (= ${binary:Version}),
         libotbextendedfilename-6.6-1 (= ${binary:Version}),
         libotbfuzzy-6.6-1 (= ${binary:Version}),
         libotbgdaladapters-6.6-1 (= ${binary:Version}),
         libotbice-6.6-1 (= ${binary:Version}),
         libotbimagebase-6.6-1 (= ${binary:Version}),
         libotbimageio-6.6-1 (= ${binary:Version}),
         libotbimagemanipulation-6.6-1 (= ${binary:Version}),
         libotbiobsq-6.6-1 (= ${binary:Version}),
         libotbiogdal-6.6-1 (= ${binary:Version}),
         libotbiokml-6.6-1 (= ${binary:Version}),
         libotbiolum-6.6-1 (= ${binary:Version}),
         libotbiomstar-6.6-1 (= ${binary:Version}),
         libotbioonera-6.6-1 (= ${binary:Version}),
         libotbiorad-6.6-1 (= ${binary:Version}),
         libotbiotilemap-6.6-1 (= ${binary:Version}),
         libotblearningbase-6.6-1 (= ${binary:Version}),
         libotbmapla-6.6-1 (= ${binary:Version}),
         libotbmathparser-6.6-1 (= ${binary:Version}),
         libotbmathparserx-6.6-1 (= ${binary:Version}),
         libotbmetadata-6.6-1 (= ${binary:Version}),
         libotbmonteverdi-6.6-1 (= ${binary:Version}),
         libotbmonteverdicore-6.6-1 (= ${binary:Version}),
         libotbmonteverdigui-6.6-1 (= ${binary:Version}),
         libotbopenthreadsadapters-6.6-1 (= ${binary:Version}),
         libotbossimadapters-6.6-1 (= ${binary:Version}),
         libotbossimplugins-6.6-1 (= ${binary:Version}),
         libotbpolarimetry-6.6-1 (= ${binary:Version}),
         libotbprojection-6.6-1 (= ${binary:Version}),
         libotbqtadapters-6.6-1 (= ${binary:Version}),
         libotbqtwidget-6.6-1 (= ${binary:Version}),
         libotbrcc8-6.6-1 (= ${binary:Version}),
         libotbsampling-6.6-1 (= ${binary:Version}),
         libotbsiftfast-6.6-1 (= ${binary:Version}),
         libotbstatistics-6.6-1 (= ${binary:Version}),
         libotbstreaming-6.6-1 (= ${binary:Version}),
         libotbsupervised-6.6-1 (= ${binary:Version}),
         libotbtestkernel-6.6-1 (= ${binary:Version}),
         libotbtransform-6.6-1 (= ${binary:Version}),
         libotbvectordatabase-6.6-1 (= ${binary:Version}),
         libotbvectordataio-6.6-1 (= ${binary:Version}),
         libotbwavelet-6.6-1 (= ${binary:Version}),
         libqwt-qt5-dev,
         libsvm-dev,
         monteverdi (= ${binary:Version}),
         otb-testdriver (= ${binary:Version}),
         ${misc:Depends}
Conflicts: libotb3-dev,
           libotb4-dev
Description: Free library of image processing algorithms - development
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the development files needed to build your own OTB
 applications and modules.

Package: otb-qgis
Architecture: any
Section: misc
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ORFEO Toolbox library - otbQgisDescriptor
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the otbQgisDescriptor application.

Package: otb-testdriver
Architecture: any
Section: misc
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ORFEO Toolbox library - OTBTestDriver
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBTestDriver application.

Package: libotbice-6.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIce
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIce shared library.

Package: libotbiolum-6.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOLUM
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOLUM shared library.

Package: libotbiomstar-6.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOMSTAR
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOMSTAR shared library.

Package: libotbioonera-6.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOONERA
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOONERA shared library.

Package: libotbiorad-6.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIORAD
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIORAD shared library.

Package: libotbiotilemap-6.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOTileMap
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOTileMap shared library.

Package: libotbiogdal-6.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOGDAL
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOGDAL shared library.

Package: libotbiobsq-6.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOBSQ
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOBSQ shared library.

Package: libotbiokml-6.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBIOKML
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .
 This package contains the OTBIOKML shared library.

Package: libotbcurladapters-6.6-1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ORFEO Toolbox library - OTBCurlAdapters
 ORFEO Toolbox (OTB) is distributed as an open source library of image
 processing algorithms. OTB is based on the medical image processing library
 ITK and offers particular functionalities for remote sensing image processing
 in general and for high spatial resolution images in particular.
 .

=== debian/rules ===
#!/usr/bin/make -f
#
# Copyright (C) 2010-2014 CNES - Centre National d'Etudes Spatiales
# Author: Sebastien DINOT <sebastien.dinot@c-s.fr>
#

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export DEB_LDFLAGS_MAINT_APPEND = "-Wl,--as-needed"

include /usr/share/dpkg/pkg-info.mk

DEB_BUILD_ARCH     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifndef PKGVERSION
    PKGVERSION=1
endif

TEMPLATES=$(wildcard debian/*lintian-overrides.in)

OTB_VERSION_MAJOR  = $(shell sed -ne 's/set(OTB_VERSION_MAJOR "\([0-9]*\)")/\1/p' CMakeLists.txt)
OTB_VERSION_MINOR  = $(shell sed -ne 's/set(OTB_VERSION_MINOR "\([0-9]*\)")/\1/p' CMakeLists.txt)
OTB_VERSION_PATCH  = $(shell sed -ne 's/set(OTB_VERSION_PATCH "\([0-9]*\)")/\1/p' CMakeLists.txt)
OTB_VERSION_SONAME = $(OTB_VERSION_MAJOR).$(OTB_VERSION_MINOR)
OTB_VERSION_FULL   = $(OTB_VERSION_MAJOR).$(OTB_VERSION_MINOR).$(OTB_VERSION_PATCH)

UPSTREAM_VERSION = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

OTB_USE_SSE_FLAGS=ON
ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
	OTB_USE_SSE_FLAGS=OFF
endif

CMAKE_FLAGS = \
	-DBUILD_EXAMPLES:BOOL=OFF \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING:BOOL=OFF \
	-DCMAKE_BUILD_TYPE:STRING=Release \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DOTB_INSTALL_ARCHIVE_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
	-DOTB_INSTALL_LIBRARY_DIR:STRING=lib/$(DEB_HOST_MULTIARCH) \
	-DOTB_USE_6S:BOOL=OFF \
	-DOTB_USE_CURL:BOOL=ON \
	-DOTB_USE_GLEW:BOOL=ON \
	-DOTB_USE_GLFW:BOOL=ON \
	-DOTB_USE_LIBKML:BOOL=ON \
	-DOTB_USE_LIBSVM:BOOL=ON \
	-DOTB_USE_MAPNIK:BOOL=OFF \
	-DOTB_USE_MUPARSER:BOOL=ON \
	-DOTB_USE_MUPARSERX:BOOL=ON \
	-DOTB_USE_OPENCV:BOOL=ON \
	-DOTB_USE_OPENGL:BOOL=ON \
	-DOTB_USE_QT:BOOL=ON \
	-DOTB_USE_QWT:BOOL=ON \
	-DOTB_USE_SSE_FLAGS:BOOL=$(OTB_USE_SSE_FLAGS) \
	-DOTB_WRAP_PYTHON3:BOOL=ON


DEBPKGNAME     := $(DEB_SOURCE)
pkgcli:=$(DEBPKGNAME)-bin
pkggui:=$(DEBPKGNAME)-bin-qt
pkglib:=lib$(DEBPKGNAME)
pkgdev:=$(pkglib)-dev

templates:

	for TEMPLATE in $(TEMPLATES) ; do \
		sed -e 's/@SOVERSION@/$(OTB_VERSION_SONAME)-1/g' $$TEMPLATE > `echo $$TEMPLATE | sed 's/.lintian-overrides.in$$/-$(OTB_VERSION_SONAME)-1.lintian-overrides/'` ; \
	done
	sed -e 's/@SOVERSION@/$(OTB_VERSION_SONAME)-1/g' debian/control.in > debian/control
	sed -e 's/@SOVERSION@/$(OTB_VERSION_SONAME)/g' debian/libotb-dev.install.in > debian/libotb-dev.install

# rather use all libs since the installed libs are spread over several packages
OTB_LIB_DIRS = $(CURDIR)/debian/tmp/usr/lib

%:
	dh $@ --with python3,pkgkde_symbolshelper --parallel

override_dh_auto_configure: templates
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_makeshlibs:
	dh_makeshlibs -- -c0 -v$(UPSTREAM_VERSION)

override_dh_shlibdeps:
	dh_shlibdeps -l$(OTB_LIB_DIRS)

override_dh_install:
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/otb/LICENSE
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/otb/VERSION
	rm -f $(CURDIR)/debian/tmp/usr/lib/*/otb/python*/otbApplication.pyc
	dh_install --list-missing
	rm -f $(CURDIR)/debian/$(pkglib)/usr/lib/$(DEB_HOST_MULTIARCH)/libOTBWrapper*
	rm -f $(CURDIR)/debian/$(pkgdev)/usr/lib/$(DEB_HOST_MULTIARCH)/libOTBWrapper*

override_dh_installchangelogs:
	dh_installchangelogs RELEASE_NOTES.txt

override_dh_installdocs:
	dh_installdocs -A NOTICE

override_dh_python3:
	dh_python3
	dh_numpy3

.PHONY: templates
